from collections import deque, defaultdict

n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]


graph = defaultdict(list)
for a, b in roads:
    graph[a].append(b)
    graph[b].append(a)

def bfs(start, max_distance):
    distances = {start: 0}
    queue = deque([(start, 0)])
    while queue:
        current, dist = queue.popleft()
        if dist < max_distance:
            for neighbor in graph[current]:
                if neighbor not in distances:
                    distances[neighbor] = dist + 1
                    queue.append((neighbor, dist + 1))
    return distances


guarded_warehouses = set()
for p, h in guards:
    reachable = bfs(p, h)
    guarded_warehouses.update(reachable.keys())


print(len(guarded_warehouses))
print(" ".join(map(str, sorted(guarded_warehouses))))
